\ 430eforth-fr5969-43n7vis :  gpio --> gpio-2207.fs                   MM-210323
\ ------------------------------------------------------------------------------
\ MIT License (C) 2022 430eForth Workbench Project

\ MSP430FR5969 GPIO Module register access

\ Required: * MSP430FR5969 MCU with 430eForth43n7vis
\           * e4thcom terminal 0.8.x or later 
\                     options: -t 430eforth-xas -p xas:target:lib

\ Used:
\  2CONSTANT
\  reg8 words
\  !  @  bi@  bix  bic  bis  u/i
\  reg16 words
\  !  @  bi@  bix  bic  bis  u/i

\ Provided:
\  forth words
\   P1  P2  P3  P4  \ The GPIO Ports that give access to the GPIO Registers.
\  gpio words
\   IV  IFG  IE  IES  SELC  SEL1  SEL0  REN  DIR  OUT  IN  \ GPIO Port Registers
\   pin:            \ Port Pin defining word
\
\ ------------------------------------------------------------------------------

-fr5969-  \ MSP430FR5969 only

#require reg8
#require reg16
#require 2constant

forth definitions decimal

voc gpio  gpio definitions      \ GPIO context

\ The gpio data structure:
\ All fields except PxIV are reg8 data items.
$00 reg8 field: IN  ( a0 -- a1 , C: reg8 )
 1+ reg8 field: OUT
 1+ reg8 field: DIR
 1+ reg8 field: REN
 drop
$0A reg8 field: SEL0
 1+ reg8 field: SEL1
 drop
$16 reg8 field: SELC
 drop
$18 reg8 field: IES
 1+ reg8 field: IE
 1+ reg8 field: IFG
 drop

\   Px |  P1  |  P2  |  P3  |  P4        
\ a.Px | $200 | $201 | $220 | $221
\ a.IV | $20E | $21E | $22E | $23E

  reg16 item
: IV ( a.px -- a.IVreg )  \ a.Px e $[ 200,201,220,221 ]
  dup 1 and if $1D else $0E then +
;

\ Create a port pin identifier.
: pin: ( "name" mask a.Px -- )  \ name ( -- mask a.Px , C: gpio )
  item 2constant
;

forth definitions

$200 gpio item constant P1 ( -- a0.Px , C: gpio )
$201 gpio item constant P2
$220 gpio item constant P3
$221 gpio item constant P4

\ -----------------------------------------------------------------------------
\ Last revision: MM-220705 port: removed
\                MM-220627 reg16 added

\ Use  #include gpio-examples.fs  to see some usage examples.

